1,1248c1,847
< //
< // CIMServer.java
< //
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
< //
< //      http://www.snia.org/resources/openSource.html
< //
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is CIMServer.java
< //
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s):
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2.
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< // $Id$
< //
< // $Log$
< // Revision 1.17  2001/07/22 13:03:13  davidsi
< // - Added support for permissions checks (from Viktor).
< //
< // Revision 1.16  2001/07/08 16:09:14  davidsi
< // - Get DEFAULT_PORT from CIMNameSpace.
< //
< // Revision 1.15  2001/06/23 13:59:10  davidsi
< // - Remove ^Ms
< //
< // Revision 1.14  2001/06/23 12:22:00  davidsi
< // - added support for running as a servlet within a webserver.
< //
< // Revision 1.12  2001/01/21 17:31:37  davidsi
< // - Added configuration manager to allow cimom to be configured from
< //   properties.
< //
< // Revision 1.11  2000/11/06 18:45:10  davidsi
< // - Temp workaround. CIMOM now has knowledge of its base url - should
< //   be fetched from somewhere else.
< //
< // Revision 1.10  2000/09/15 17:12:09  davidsi
< // - createInstance() now returns CIMObjectPath.
< //
< // Revision 1.9  2000/08/16 05:59:56  shawn
< // merge P_TOMCAT31 branch
< //
< // Revision 1.8.6.1  2000/08/10 00:03:32  shawn
< // head merge
< //
< // Revision 1.8  2000/07/10 17:35:49  davidsi
< // - Fixed problems in starting server with RMI.
< //
< // Revision 1.7  2000/05/18 14:23:02  davidsi
< // - Made CIMServerLocate() public.
< //
< // Revision 1.6  2000/05/11 10:12:03  davidsi
< // - Fixed tabs.
< //
< // Revision 1.5  2000/05/09 20:17:48  davidsi
< // - Fixes to allow CIMOMHandle to be used within a provider.
< //
< // Revision 1.4  2000/05/06 17:15:33  davidsi
< // - Brought in line with SUN WBEM APIs 2.2
< //
< // Revision 1.3  2000/04/09 13:42:29  davidsi
< // - Added necessary syncrhonized statements to support multithreaded
< //   operation.
< // - Remove replaceNameSpace as it is not being used.
< // - Fixed removeNameSpace() so it removes all "child" namespaces.
< //
< // Revision 1.2  2000/02/13 15:09:47  davidsi
< // - Added text to cover re-use of Solaris WBEM APIs.
< //
< // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
< // Initial version.
< //
< //
< //
< package org.snia.wbemcmd.cimom;
< 
< 
< import java.io.*;
< import java.util.Enumeration;
< import java.util.Vector;
< import java.rmi.*;
< import java.rmi.server.*;
< import java.net.*;
< import org.snia.wbem.cim.*;
< import org.snia.wbem.client.CIMIndicationListener;
< import org.snia.wbemcmd.xml.HTTPInput;
< import org.snia.wbemcmd.xml.XMLNameSpace;
< import org.snia.wbemcmd.utils.SimpleEnum;
< import org.snia.wbemcmd.utils.Log;
< import org.snia.wbemcfg.GlobalConfig;
< import org.snia.wbemcmd.indication.IndicationProcessor;
< 
< //
< // The CIMOM!
< //
< public class CIMServer implements CIMImplementation  {
<     static IndicationProcessor indicationProcessor=null;
<     static private CIMServer localServer;
<     static private Vector nameSpaces=new Vector();  // ServerNameSpace instances
<     static public String url = "/cimom";  // TODO this should be set up when the
<                                           // CIMOM starts to reflect the
<                                           // actual url
<                                           // that its listening to
<     private String userName;
<     private String password;
< 
<     //
<     // CIMServerLocate
<     //
<     public static synchronized CIMServer CIMServerLocate() throws CIMException{
<         return(localServer);
<     }
< 
<     //
<     // CIMServerGetNameSpaces
<     //
<     public static synchronized Vector CIMServerGetNameSpaces() {
<         Vector ret=new Vector();
< 
<         for(int j=0;j<nameSpaces.size();j++) {
<             ServerNameSpace sns=(ServerNameSpace)(nameSpaces.elementAt(j));
<             ret.addElement(sns.getNameSpace());
<         }
<         return(ret);
<     }
< 
<     //
<     // findNameSpace
<     //
<     static synchronized ServerNameSpace findNameSpace(CIMObjectPath name)
<             throws CIMException {
<         String namespace=name.getNameSpace();
<         int i;
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             String ns=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
<             if ( ns.equalsIgnoreCase(namespace))
<                 return((ServerNameSpace)(nameSpaces.elementAt(i)));
<         }
<         throw new CIMException("NameSpace "+namespace+" not in manager");
<      }
< 
<     //
<     // findNameSpace
<     //
<     private synchronized ServerNameSpace findNameSpace(CIMNameSpace ns)
<             throws CIMException {
<         String namespace=ns.getNameSpace();
<         int i;
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
<             if ( str.equalsIgnoreCase(namespace))
<                 return((ServerNameSpace)(nameSpaces.elementAt(i)));
<         }
<         throw new CIMException("NameSpace "+namespace+" not in manager");
<     }
< 
< 
< 
<     //
<     // removeNameSpace
<     //
<     public synchronized static void removeNameSpace(CIMNameSpace ns) throws CIMException
<     {
<         String namespace=ns.getNameSpace();
<         int i;
< 
<           // QW 513             For access control.
<         permit("config","delete","removeNameSpace("+ namespace +")");
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
<             if ( str.equalsIgnoreCase(namespace)) {
<                 nameSpaces.removeElementAt(i);
<                 //
<                 // Search for any child namespaces and remove those
<                 //
<                 String parentNameSpace=ns.getNameSpace();
<                 int len=parentNameSpace.length();
< 
<                 for(;;) {
<                     //
<                     // Iterate until all paths scanned - note that this is
<                     // a recursive process
<                     //
<                     int j;
<                     Vector paths=CIMServer.CIMServerGetNameSpaces();
<                     for(j=0;j<paths.size();j++) {
<                         String childSpace=(String)(paths.elementAt(j));
< 
<                         if (childSpace.length()>len &&
<                             childSpace.substring(0,len).equalsIgnoreCase(parentNameSpace) &&
<                             childSpace.charAt(len)=='/') {
<                             CIMNameSpace childNameSpace=new CIMNameSpace(ns.getHost(),
<                                                                          childSpace);
<                             removeNameSpace(childNameSpace);
<                             break;
<                         }
<                     }
<                     if (j==paths.size())
<                         break;
<                 }
<                 return;
<             }
<         }
<         throw new CIMException("NameSpace "+namespace+" not found");
<     }
< 
<     //
<     // addNameSpace
<     //
<     public synchronized static void addNameSpace(CIMNameSpace ns)
<             throws CIMException
<         {
<         ServerNameSpace cns=new ServerNameSpace(ns);
<         String namespace=cns.getNameSpace();
<         int i;
< 
<         // QW 513       For access control.
<         permit("config", "create","addNameSpace(" + namespace + ")");
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
<             if ( str.equalsIgnoreCase(namespace)) {
<                 throw new CIMException("NameSpace "+namespace+" is already created in manager");
<             }
<         }
<         nameSpaces.addElement(cns);
<         //
<         // Now create the __Namespace class
<         //
<         CIMClass cimClass=new CIMClass();
<         cimClass.setName(XMLNameSpace.NAMESPACECLASS);
<         CIMQualifier cimQualifier=new CIMQualifier("provider");
<         cimQualifier.setValue(new CIMValue(XMLNameSpace.PROVIDER,
<                            CIMDataType.getPredefinedType(CIMDataType.STRING)));
<         CIMQualifier cimQualifierKey=new CIMQualifier("Key");
<         cimQualifierKey.setValue(new CIMValue("true",
<                            CIMDataType.getPredefinedType(CIMDataType.STRING)));
< 
<         CIMProperty cimProp=new CIMProperty();
<         cimProp.setType(CIMDataType.getPredefinedType(CIMDataType.STRING));
<         cimProp.setName(XMLNameSpace.NAMEPROPERTY);
< 
<         cimProp.addQualifier(cimQualifierKey);
<         cimClass.addQualifier(cimQualifier);
<         cimClass.addProperty(cimProp);
< 
<         CIMObjectPath classObjPath=new CIMObjectPath(
<                                 XMLNameSpace.NAMESPACECLASS,ns.getNameSpace());
<         try {
<             cns.deleteClass(classObjPath);
<         } catch (CIMException ce) {
<             //
<             // Do nothing - it might not have been created. However
<             // if it was there is now deleted so we can create it
<             // again!
<             //
<         }
<         cns.addCIMClass(classObjPath,cimClass);
< 
<         cns.makeHandle();
< 
<         if (indicationProcessor==null)
<            indicationProcessor=IndicationProcessor.make(ns);
<     }
< 
<     //
<     // authenticate
<     //
<     public void authenticate(String iuserName,String ipassword)
<         throws RemoteException,CIMException {
<         //
<         // TODO - need to use these for authentication
<         //
<         userName=iuserName;
<         password=ipassword;
<     }
< 
< 
<     //
<     // CIMServer
<     //
<     public CIMServer() throws CIMException,RemoteException
<     {
<     }
< 
< 
< 
<     //
<     // CIMServer
<     //
<     public CIMServer(CIMNameSpace name) throws CIMException, RemoteException{
<         addNameSpace(name);
<     }
< 
< 
< 
<     //
<     // CIMServer
<     //
<     public CIMServer(CIMNameSpace name, String userName,String passwd)
<             throws CIMException,RemoteException {
<         addNameSpace(name);
<     }
< 
< 
<     //
<     // CIMServer
<     //
<     public CIMServer(CIMNameSpace name,String userName,String passwd,int protocol)
<             throws CIMException,RemoteException{
<     }
< 
< 
<     //
<     // createNameSpace
<     //
<     public synchronized void createNameSpace(CIMNameSpace ns)
<             throws RemoteException, CIMException{
<         addNameSpace(ns);
<     }
< 
< 
<     //
<     // deleteNameSpace
<     //
<     public synchronized void deleteNameSpace(CIMNameSpace cns)
<             throws RemoteException, CIMException{
<         String namespace=cns.getNameSpace();
<         int i;
< 
<         // QW 513
<         permit("config","delete","deleteNameSpace(" + namespace +")");
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             String ns=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
<             if ( ns.equalsIgnoreCase(namespace)) {
<                 nameSpaces.removeElementAt(i);
<                 return;
<             }
<         }
<         throw new CIMException("NameSpace "+namespace+" could not be found");
<     }
< 
< 
<     //
<     // deleteClass
<     //
<     public void deleteClass(CIMObjectPath path)
<             throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("class", path, null), "delete",
<                "deleteClass("+ path.getObjectName() +")");
< 
<         ServerNameSpace sns;
< 
<         sns=findNameSpace(path);
<         sns.deleteClass(path);
<     }
< 
< 
<     //
<     //deleteInstance
<     //
<     public void deleteInstance(CIMObjectPath path)
<                 throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("instance", path, null), "delete",
<                "deleteInstance("+path.getObjectName()+")");
< 
<         ServerNameSpace sns;
< 
<         sns=findNameSpace(path);
<         sns.deleteInstance(path);
<     }
< 
< 
< 
< 
<     //deleteQualifierType
<     //
<     public synchronized void deleteQualifierType(CIMObjectPath path)
<                 throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("qualifier", path, null), "delete",
<                "deleteQualifier("+path.getObjectName()+")");
< 
<         findNameSpace(path).deleteQualifierType(path);
<     }
< 
< 
< 
<     //enumNameSpace
<     //
<     public Enumeration enumNameSpace(CIMObjectPath path,boolean deep)
<                 throws RemoteException, CIMException {
<                 int i;
< 
<         // QW 513
<         permit("config", "read",
<                "enumerateNameSpace("+path.getNameSpace()+")");
< 
<         SimpleEnum se=new SimpleEnum();
< 
<         for(i=0;i<nameSpaces.size();i++) {
<             se.addElement( ((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace() );
<         }
<         return(se);
<     }
< 
<     //
<     // enumClass
<     //
<     public Enumeration enumClass(CIMObjectPath path,
<                    boolean deep,boolean localOnly)
<                    throws RemoteException , CIMException{
< 
<         // QW 513
<         permit(buildID("class", path, null), "read",
<                "enumerateClass("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).enumClass(path,deep,localOnly));
<     }
< 
< 
<     //
<     // enumClass
<     //
<     public Enumeration enumClass(CIMObjectPath path,
<                    boolean deep) throws RemoteException, CIMException {
<         // QW 513
<         permit(buildID("class", path, null), "read",
<                "enumerateClass("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).enumClass(path,deep));
<     }
< 
<     //
<     // enumInstances
<     //
<     public Enumeration enumInstances(CIMObjectPath path,
<                        boolean deep) throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("instance",path,null), "read",
<                "enumerateInstance("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).enumInstances(path,deep));
<     }
< 
< 
<     //
<     // enumInstances
<     //
<     public Enumeration enumInstances(CIMObjectPath path,
<                        boolean deep,
<                        boolean localOnly) throws RemoteException, CIMException{
<         // QW 513
<         permit(buildID("instance",path,null), "read",
<                "enumerateInstance("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).enumInstances(path,deep,localOnly));
<     }
< 
<     //
<     // execQuery
<     //
<     public Enumeration execQuery(CIMObjectPath path,
<                        String query,
<                        int ql) throws RemoteException, CIMException{
<         permit(buildID("instance",path,null), "read",
<                "execQuery("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).execQuery(path,query,ql));
<     }
< 
<     //
<     // enumQualifierTypes
<     //
<     public Enumeration enumQualifierTypes(CIMObjectPath path)
<                 throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("qualifier",path,null), "read",
<                "enumerateQualifiers("+path.getNameSpace()+")");
< 
<         return(findNameSpace(path).enumQualifierTypes());
<     }
< 
< 
< 
<     //
<     // getClass
<     //
<     public CIMClass getClass(CIMObjectPath path,
<                boolean localOnly) throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("class",path,null), "read",
<                "getClass("+path.getObjectName()+")");
< 
<         if (localOnly)
<             return(findNameSpace(path).getCIMClass(path).localElements());
<         return(findNameSpace(path).getCIMClass(path));
<    }
< 
< 
<     //
<     // getInstance
<     //
<     public CIMInstance getInstance(CIMObjectPath path,
<                      boolean localOnly) throws RemoteException, CIMException {
< 
<         // QW 513
<         permit(buildID("instance",path,null), "read",
<                "getInstance("+path.getObjectName()+")");
< 
<         ServerNameSpace sns;
<         CIMInstance ci;
< 
<         sns=findNameSpace(path);
<         ci=sns.getInstance(path,localOnly);
< 
<         return(ci);
<     }
< 
< 
<     //
<     //invokeMethod
<     //
<     public CIMValue invokeMethod(CIMObjectPath path,
<                    String methodName,Vector in,
<                    Vector out) throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("method",path,"methodName"), "execute",
<                "invokeMethod" + path.getObjectName() + "." + methodName +"()");
< 
<         return(findNameSpace(path).invokeMethod(path,methodName,in,out));
<     }
< 
< 
<     //
<     // getQualifierType
<     //
<     public CIMQualifierType getQualifierType(CIMObjectPath path)
<             throws RemoteException, CIMException{
< 
<         // QW 513
<         permit(buildID("qualifier",path,null), "read",
<                "getQualifierType("+path.getObjectName()+")" );
< 
<         return(findNameSpace(path).getQualifierType(path));
<     }
< 
< 
<     //
<     // createQualifierType
<     //
<     public void createQualifierType(CIMObjectPath path,
<                       CIMQualifierType qt) throws RemoteException, CIMException{
<         // QW 513
<         permit(buildID("qualifier",path,null), "create",
<                "createQualifierType("+qt.getName()+")!" );
< 
<         findNameSpace(path).createQualifierType(path,qt);
<     }
< 
<     //
<     // setQualifierType
<     //
<     public void setQualifierType(CIMObjectPath path,
<                    CIMQualifierType qt) throws RemoteException, CIMException{
<         // QW 513
<         permit(buildID("qualifier",path,null), "write",
<                "setQualifierType("+qt.getName()+")" );
< 
<         findNameSpace(path).setQualifierType(path,qt);
<     }
< 
<     //
<     // createClass
<     //
<     public void createClass(CIMObjectPath path,
<               CIMClass cc) throws RemoteException , CIMException{
<         // QW 513
<         permit(buildID("class",path,null), "create",
<                "createClass("+cc.getName()+")");
< 
<         findNameSpace(path).addCIMClass(path,cc);
<     }
< 
< 
<     //
<     // setClass
<     //
<     public void setClass(CIMObjectPath path,
<            CIMClass cc) throws RemoteException, CIMException {
<         // QW 513
<         permit(buildID("class",path,null), "write",
<                "setClass("+cc.getName()+")");
< 
<         findNameSpace(path).setCIMClass(path,cc);
<     }
< 
< 
<     //
<     // createInstance
<     //
<     public CIMObjectPath createInstance(CIMObjectPath path,
<                  CIMInstance ci) throws RemoteException, CIMException{
<         // QW 513
<         permit(buildID("instance",path,null), "create",
<                "createInstance("+ci.getName()+")");
< 
<         return(findNameSpace(path).addCIMInstance(path,ci));
<     }
< 
< 
<     //
<     // setInstance
<     //
<     public void setInstance(CIMObjectPath path,
<               CIMInstance ci) throws RemoteException, CIMException{
<         // Qw 513
<         permit(buildID("instance",path,null), "write",
<                "setInstance("+ci.getName()+")");
< 
<          findNameSpace(path).setInstance(path,ci);
<     }
< 
< 
<     //
<     // getProperty
<     //
<     public CIMValue getProperty(CIMObjectPath path,
<                   String propertyName) throws RemoteException, CIMException{
<         // Qw 513
<         permit(buildID("property",path,propertyName), "read",
<                "getProperty("+ path.getObjectName() + "," + propertyName +")");
< 
<         return(findNameSpace(path).getProperty(path,propertyName));
<     }
< 
< 
<     //
<     // setProperty
<     //
<     public void setProperty(CIMObjectPath path,
<               String propertyName,
<               CIMValue newValue) throws RemoteException, CIMException{
<         // Qw 513
<         permit(buildID("property",path,propertyName), "write",
<                "setProperty(" +path.getObjectName() + "," + propertyName +")");
< 
<         findNameSpace(path).setProperty(path,propertyName,newValue);
<     }
< 
<     //
<     // associatorNames
<     //
<     public Enumeration associatorNames(CIMObjectPath path,String assocClass,
<                                         String resultClass,
<                                         String role,String resultRole) throws CIMException {
<         // Qw 513
<         permit(buildID("instance",path,null), "read",
<                "associatorNames("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).associatorNames(path,
<                                    assocClass,resultClass,role,resultRole));
<     }
< 
<     //
<     // associators
<     //
<     public Enumeration associators(CIMObjectPath path,
<                                         String assocClass,
<                                         String resultClass,
<                                         String role,
<                                         String resultRole,
<                                         boolean includeQualifiers,
<                                         boolean includeClassOrigin,
<                                         String propertyList[])throws CIMException {
<         // Qw 513
<         permit(buildID("instance",path,null), "read",
<                "associators("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).associators(path,assocClass,
<                           resultClass,role, resultRole,includeQualifiers,
<                           includeClassOrigin,propertyList));
<     }
< 
<     //
<     // referenceNames
<     //
<     public Enumeration referenceNames(CIMObjectPath path,
<                                         String resultClass,
<                                         String role) throws CIMException {
<         // Qw 513
<         permit(buildID("instance",path,null), "read",
<                "referenceNames("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).referenceNames(path,resultClass,role));
<     }
< 
<     //
<     // references
<     //
<     public Enumeration references(CIMObjectPath path,
<                                             String resultClass,
<                                             String role,
<                                             boolean includeQualifiers,
<                                             boolean includeClassOrigin,
<                                             String propertyList[]
<                                         ) throws CIMException {
<         // Qw 513
<         permit(buildID("instance",path,null), "read",
<                "references("+path.getObjectName()+")");
< 
<         return(findNameSpace(path).references(path,resultClass,role,
<                                               includeQualifiers,
<                                               includeClassOrigin,
<                                               propertyList));
<     }
< 
< 
<     //
<     // references
<     //
<     public static void createLocalServer(CIMNameSpace cns)throws CIMException,RemoteException {
<         localServer=new CIMServer();
<         localServer.addNameSpace(cns);
<     }
< 
< 
<     /**
<      * Instantiate the configuration manager and load the configuration
<      * properties; create and initialize the configuration RMI server to
<      * allow configuration properties to be updated dynamically.
<      */
<     private void initConfigManager()
<     {
<         ConfigManager configManager;
< 
<         //
<         // Instantiate the configuration manager and load the configuration
<         // properties.
<         //
<         configManager = new ConfigManager();
<         try
<         {
<             configManager.loadConfigProperties();
<         }
<         catch (FileNotFoundException e)
<         {
<             System.err.println("Configuration File could not be found: " +
<                                e.getMessage() );
<             System.err.println("Default configuration will be used.");
<         }
<         catch (IOException e)
<         {
<             System.err.println("IOException: " + e.getMessage() );
<             System.err.println("Default configuration will be used.");
<         }
< 
<         //
<         // Create and initialize the configuration RMI server
<         //
<         ConfigManagerImpl configImpl = null;
<         String            serverURL  = null;
< 
<         try
<         {
<             configImpl = new ConfigManagerImpl(configManager);
<         }
<         catch (RemoteException e)
<         {
<             System.err.println("WARNING:Could not start configuration RMI server.");
<             System.err.println("Configuration properties may not be updated " +
<                         "dynamically.");
<             return;
<         }
< 
<         try
<         {
<             serverURL = InternalRMIPropertyOwner.getConfigServerURL();
<         }
<         catch (java.net.UnknownHostException e)
<         {
<             System.err.println("Config RMI connection did not start: " +
<                                "Could not determine server hostname.");
<             System.err.println("Configuration properties may not be updated " +
<                                "dynamically.");
<             return;
<         }
< 
<         try
<         {
<             Naming.rebind(serverURL, configImpl);
<         }
<         catch (AccessException e)
<         {
<             System.err.println("Config RMI connection did not start: " +
<                                "Access Exception.");
<             System.err.println("Configuration properties may not be updated " +
<                                "dynamically.");
<         }
<         catch (RemoteException e)
<         {
<             //
<             // A RemoteException from Naming.rebind() indicates that the
<             // registry could not be contacted.
<             //
<             System.err.println("Could not start configuration RMI server.");
<             System.err.println("Configuration properties may not be updated " +
<                                "dynamically.");
<             System.err.println("Run 'rmiregistry " +
<                                InternalRMIPropertyOwner.getRMIPortNumber() +
<                                "' to enable the RMI connection before " +
<                                "starting the CIM server.");
<         }
<         catch (MalformedURLException e)
<         {
<             System.err.println("Config RMI connection did not start: " +
<                                e.getMessage() );
<             System.err.println("Configuration properties may not be updated " +
<                                "dynamically.");
<         }
<     }
< 
<     /**
<      * create and initialize the XMLRMIInputImpl RMI server to
<      * allow CIM Servlet to access CIM Server
<      */
<     private void initXmlRmiInterface()
<     {
<         //
<         // Create and initialize the XMLRMI RMI server
<         //
<         XMLRMIInputImpl xmlRmiInputImpl = null;
<         String          serverURL       = null;
< 
<         try
<         {
<             // TODO:
<             //System.setSecurityManager( new RMISecurityManager() );
<             //
<             xmlRmiInputImpl = new XMLRMIInputImpl();
<             serverURL   = InternalRMIPropertyOwner.getXMLRMIServerURL();
<             Naming.rebind(serverURL, xmlRmiInputImpl);
<         }
<         catch (AccessException e)
<         {
<             System.err.println("XML RMI connection did not start: " +
<                                "Access Exception.");
<             Log.println("XML RMI connection did not start: " +
<                                "Access Exception.");
<         }
<         catch (RemoteException re)
<         {
<             //
<             // A RemoteException from Naming.rebind() indicates that the
<             // registry could not be contacted.
<             //
<             System.err.println("Could not start XML RMI server. "+re);
<             re.printStackTrace();
<             System.err.println("Could not start XML RMI server.");
<             Log.println("Could not start XML RMI server.");
<             System.err.println("Run 'rmiregistry " +
<                                InternalRMIPropertyOwner.getRMIPortNumber() +
<                                "' to enable the RMI connection before " +
<                                "starting the CIM server.");
<             Log.println("Run 'rmiregistry " +
<                                InternalRMIPropertyOwner.getRMIPortNumber() +
<                                "' to enable the RMI connection before " +
<                                "starting the CIM server.");
<         }
<         catch (MalformedURLException mre)
<         {
<             System.err.println(" MalformedURLException encountered while trying to bind to " + serverURL);
<             Log.println(" MalformedURLException encountered while trying to bind to " + serverURL);
<         }
<         catch (java.net.UnknownHostException ue)
<         {
<             System.err.println("XML RMI connection did not start: " +
<                                ue.getMessage() );
<             Log.println("XML RMI connection did not start: " +
<                                ue.getMessage() );
<         }
<     }
< 
< 
< 
< 
< 
< 
<     //
<     // The main() for the CIMOM
<     //
<     public static void main(String[] args) {
<         int i;
<         boolean dormi=false;
<         int port=CIMNameSpace.DEFAULT_PORT;
< 
<         for(i=0;i<args.length;i++) {
<             if (args[i].equalsIgnoreCase("-r"))
<                 dormi=true;
<             if (args[i].equalsIgnoreCase("-p")) {
<                 i++;
<                 if (i>=args.length) {
<                     System.err.println("A port is required");
<                 } else {
<                     Integer intv=new Integer(args[i]);
<                     port=intv.intValue();
<                 }
<             }
<         }
< 
<         Log.assignLogFileName(GlobalConfig.serverDebugFile);
< 
< 
< 
<         try {
< 
< 			//System.out.println("Creating ProviderManager....");
< 			ProviderManager  ProviderManager=new ProviderManager();
< 			//System.out.println("Created ProviderManager....");
< 
<             if (dormi) {
<                 try {
<                     CIMServerRemote cs=new CIMServerRemote();
<                     localServer=cs.getCIMServer();
< 
<                     //
<                     // Load config properties and start the RMI server for
<                     // configuration updates
<                     //
<                     localServer.initConfigManager();
< 
<                     localServer.createNameSpace(new CIMNameSpace(
<                                 InetAddress.getLocalHost().getHostName(),
<                                 XMLNameSpace.DEFNAMESPACE));
<                     Naming.rebind(CIMOMHandleRMI.CIMOMName,cs);
< 
<                 } catch (java.rmi.ConnectException  e) {
<                     System.err.println("Failed to start RMI:"+e.getMessage());
<                     Log.println( "Failed to start RMI:"+e.getMessage() );
<                 }
<             } else {
<                 localServer=new CIMServer();
< 
<                 //
<                 // Load config properties and start the RMI server for
<                 // configuration updates
<                 //
<                 localServer.initConfigManager();
< 
<                 localServer.createNameSpace(new CIMNameSpace(
<                                 InetAddress.getLocalHost().getHostName(),
<                                 XMLNameSpace.DEFNAMESPACE));
< 
<             }
<         if( InternalRMIPropertyOwner.getXMLRMIEnabled() == true ) {
<             System.out.println( "CIMOM XML RMI service starting" );
<             Log.println( "CIMOM XML RMI service starting" );
<             localServer.initXmlRmiInterface();
<         } else {
<             System.out.println("CIMOM service starting on port "+port+".");
<             Log.println( "CIMOM  service starting on port "+port+"." );
<             HTTPInput input = new HTTPInput( port );
<             input.process();
<             }
< 
<         } catch (CIMException e) {
<             e.printStackTrace(System.err);
<             System.err.println("CIMOM did not start:"+e.getMessage());
<             Log.println( "CIMOM did not start:"+e.getMessage() );
<         } catch (RemoteException e) {
<             e.printStackTrace(System.err);
<             System.err.println("CIMOM did not start:"+e.getMessage());
<             Log.println( "CIMOM did not start:"+e.getMessage() );
<         } catch (MalformedURLException e) {
<             e.printStackTrace(System.err);
<             System.err.println("CIMOM did not start:"+e.getMessage());
<             Log.println( "CIMOM did not start:"+e.getMessage() );
<         } catch (java.net.UnknownHostException e) {
<             System.err.println("Could not find hostname");
<             Log.println( "Could not find hostname"+e.getMessage() );
<         } catch (Exception e) {
<             System.err.println("Java Exception:"+e.getMessage());
<             Log.println( "Java Exception:"+e.getMessage() );
<         }
<     }
< 
< 
<     // QW 427.   Methods for checking permission.
<     //    1.   buildID -- build permission ID
<     //    2.   permit
<     static String  buildID(String objType, CIMObjectPath op, String extType) {
<         String ns, obj;
< 
<         if ( objType == null || objType.length() <= 0 )
<             return new String("");
< 
<         StringBuffer sbuf = new StringBuffer(objType);
<         if ( op != null )  {
<                 ns = op.getNameSpace();
<                 obj = op.getObjectName();
<                 if ( op.getNameSpace() != null ) {
<                     sbuf.append(":" + op.getNameSpace());
<                     if ( op.getObjectName() != null ) {
<                             sbuf.append(":" + op.getObjectName());
<                             if ( extType != null )
<                                 sbuf.append(":"+extType);
<                     }
<                 }
<         }
<         return sbuf.toString();
<     }
< 
<     static void permit(String resource, String operation,
<                         String operationVerbose) throws CIMException {
< 
<         if (OperationPermission.requiresCheck &&
<             !OperationPermission.opImplementation.checkPermission(resource,
<                                                                   operation))
<             throw new CIMException(CIMException.CIM_ERR_ACCESS_DENIED,
<                                    "Insufficient permissions for " +
<                                    operationVerbose);
<     }
< 
< 
< }
< 
< 
<    class ProviderThread extends Thread
<    {
< 
< 		//String providerClassName=null;
< 		org.hp.CIMProviders.CIMProvider providerInstance=null;
< 		int intervel=-1;
< 		org.snia.wbemcfg.ProviderParameters providerParameters=null;
< 
< 		ProviderThread(org.snia.wbemcfg.ProviderParameters providerParameters) throws Exception
< 		{
< 			//provider class name will be used as the thread name
< 			super(providerParameters.getClassName());
< 
< 			try
< 			{
< 		   		this.providerInstance=(org.hp.CIMProviders.CIMProvider)(Class.forName(providerParameters.getClassName() ).newInstance());
< 			}
< 			catch(Exception e)
< 			{
< 				System.out.println("\""+e+"\"  occurred while starting the provider "+providerParameters.getClassName()+"....");
< 				throw e;
< 			}
< 
< 		  	this.intervel=providerParameters.getIntervel();
< 			this.providerParameters=providerParameters;
< 		  	//no neet to call start, this will be taken care by the ProviderManager
< 		}
< 
< 		public void run()
< 		{
< 
< 		   //this is put here because, when  the provider manager calls
< 		   //start, the initialization would be done
< 		   providerInstance.initialize(providerParameters.getParameters());
< 
<   		   int intervel_milliseconds=intervel*1000;
< 
< 
< 		  try
< 		 {
< 			//System.out.println("ProviderThread : run(): Waiting for "+intervel+"seconds..." );
< 			Thread.currentThread().sleep(30*1000);
< 		}
< 		catch(Exception e)
< 		{
< 			System.out.println("CIMServer: Error while making the provider thread sleep...."+e);
< 		}
< 
< 
< 
< 		   while(true)
< 		   {
< 			    //System.out.println("Executing "+providerParameters.getClassName()+"\'s execute()");
< 
< 				try
< 				{
< 					providerInstance.execute();
< 				}
< 				catch(Exception e)
< 				{
< 					System.out.println("\""+e+"\" occured while executing the provider "+providerParameters.getClassName());
< 				}
< 				try
< 				{
< 					//System.out.println("ProviderThread : run(): Waiting for "+intervel+"seconds..." );
< 					Thread.currentThread().sleep(intervel_milliseconds);
< 				}
< 				catch(Exception e)
< 				{
< 					System.out.println("CIMServer: Error while making the provider thread sleep...."+e);
< 				}
< 		   }
< 		}
< 
<    }
< 
< 
< 
< 
<     //added by prabhakar
<     class ProviderManager extends Thread
<     {
< 		ProviderManager()
< 		{
< 			this.start();
<    	    }
< 
<     	//added by prabhakar
<         public void run ()
<     	{
< 
< 		  Vector providerClasses=GlobalConfig.getProviderClasses();
< 
< 		  if(	providerClasses == null) return;
< 
< 		  //this variable is created to avoid repeated size calculation
<   		  int numProviders=providerClasses.size();
< 
< 
< 		  //Class[] providerClasses=new Class[numProviders];
< 		  //org.hp.CIMProviders.CIMProvider[] providers = new org.hp.CIMProviders.CIMProvider[numProviders];
< 
< 		  ProviderThread ProviderThreads[]=new ProviderThread[numProviders];
< 
< 		  //org.snia.wbemcfg.ProviderParameters provider=null;
< 
< 		  for (int i=0;i<numProviders;i++)
< 		  {
< 
< 			  try
< 			  {
< 				//provider= (org.snia.wbemcfg.ProviderParameters) (providerClasses.elementAt(i));
< 			    //System.out.println("Creating the provider class "+provider.getClassName());
< 				//providers[i]= (org.hp.CIMProviders.CIMProvider)(Class.forName(provider.getClassName() ).newInstance());
< 
< 				//call the initialize function of the provider
< 				//providers[i].initialize(provider.getParameters());
< 
< 				try
< 				{
< 					ProviderThreads[i]=new ProviderThread((org.snia.wbemcfg.ProviderParameters) (providerClasses.elementAt(i)) );
< 					ProviderThreads[i].start();
< 				}
< 				catch(Exception e)
< 				{
< 
< 				}
< 		  	  }
< 		  	  catch(Exception e)
< 		  	  {
< 				System.out.println("Exception occurred while loading the class "+providerClasses.elementAt(i)) ;
< 				e.printStackTrace();
< 		   	  }
< 		  	  //providerClass.newInstance();
< 		  }
< 
< 
< 
< 		  while(true)
< 		  {
< 			//sleep for 30 seconds, so that the sever socket is opened, before the
< 			//clients of the providers establish the connections
< 			//System.out.println("Waiting for 30 seconds so that the CIMOM is initialised");
< 
< 			try
< 			{
< 
< 				//System.out.println("ProviderManager waits for "+GlobalConfig.checking_periodicity/1000+ " seconds");
< 
< 				Thread.currentThread().sleep(GlobalConfig.checking_periodicity);
< 			}
< 			catch(Exception e)
< 			{
< 
< 			}
< 
< 			if(numProviders > 0)
< 			for (int i=0;i<numProviders;i++)
< 			{
< 
< 			  try
< 			  {
< 			    //System.out.println("Creating the provider class "+providerClasses.elementAt(i));
< 				//providers[i].execute();
< 
< 				if(ProviderThreads[i]==null)
< 				{
< 					continue;//the provider thread has not been created
< 							//this might occur of the provider class is not found....
< 				}
< 
< 				if(!ProviderThreads[i].isAlive())
< 				{
< 					//System.out.println("Thread "+ProviderThreads[i]+" is not alive. Restarted..." );
< 					ProviderThreads[i].start();
< 
< 				}
< 				//else System.out.println("Thread "+ProviderThreads[i]+" is alive." );
< 
< 
< 
< 		  	  }
< 		  	  catch(Exception e)
< 		  	  {
< 				System.out.println("Exception occurred while creating a new instance of "+providerClasses.elementAt(i)) ;
< 				e.printStackTrace();
< 		   	  }
< 		  	  //providerClass.newInstance();
< 			}
< 
< 	  	   }
<     	}
< 
< 
< 	}
---
> /*
> static char sccsid[] = "@(#)08  1.2  src/com/ibm/cimom/CIMServer.java, cimom, ICAT1, ICAT1_1.1.0.0 12/5/02 18:15:21";
> */
> 
> //
> // CIMServer.java
> //
> // The contents of this file are subject to the SNIA Public License Version 1.0
> // (the "License"); you may not use this file except in compliance with the
> // License. You may obtain a copy of the License at
> //
> //      http://www.snia.org/resources/openSource.html
> //
> // Software distributed under the License is distributed on an "AS IS" basis,
> // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
> // License for the specific language governing rights and limitations
> // under the License.
> //
> // The Original Code is CIMServer.java
> //
> // The Initial Developer of the Original Code is David Simons.
> //
> // Contributor(s):
> //
> //
> // This source uses the Solaris WBEM APIs version 2.2.
> // Synchronization will be maintained with the Solaris WBEM APIS,
> // which are being standardized through the Java Community Process.
> //
> //
> // $Id$
> //
> // $Log$
> // Revision 1.17  2001/07/22 13:03:13  davidsi
> // - Added support for permissions checks (from Viktor).
> //
> // Revision 1.16  2001/07/08 16:09:14  davidsi
> // - Get DEFAULT_PORT from CIMNameSpace.
> //
> // Revision 1.15  2001/06/23 13:59:10  davidsi
> // - Remove ^Ms
> //
> // Revision 1.14  2001/06/23 12:22:00  davidsi
> // - added support for running as a servlet within a webserver.
> //
> // Revision 1.12  2001/01/21 17:31:37  davidsi
> // - Added configuration manager to allow cimom to be configured from
> //   properties.
> //
> // Revision 1.11  2000/11/06 18:45:10  davidsi
> // - Temp workaround. CIMOM now has knowledge of its base url - should
> //   be fetched from somewhere else.
> //
> // Revision 1.10  2000/09/15 17:12:09  davidsi
> // - createInstance() now returns CIMObjectPath.
> //
> // Revision 1.9  2000/08/16 05:59:56  shawn
> // merge P_TOMCAT31 branch
> //
> // Revision 1.8.6.1  2000/08/10 00:03:32  shawn
> // head merge
> //
> // Revision 1.8  2000/07/10 17:35:49  davidsi
> // - Fixed problems in starting server with RMI.
> //
> // Revision 1.7  2000/05/18 14:23:02  davidsi
> // - Made CIMServerLocate() public.
> //
> // Revision 1.6  2000/05/11 10:12:03  davidsi
> // - Fixed tabs.
> //
> // Revision 1.5  2000/05/09 20:17:48  davidsi
> // - Fixes to allow CIMOMHandle to be used within a provider.
> //
> // Revision 1.4  2000/05/06 17:15:33  davidsi
> // - Brought in line with SUN WBEM APIs 2.2
> //
> // Revision 1.3  2000/04/09 13:42:29  davidsi
> // - Added necessary syncrhonized statements to support multithreaded
> //   operation.
> // - Remove replaceNameSpace as it is not being used.
> // - Fixed removeNameSpace() so it removes all "child" namespaces.
> //
> // Revision 1.2  2000/02/13 15:09:47  davidsi
> // - Added text to cover re-use of Solaris WBEM APIs.
> //
> // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
> // Initial version.
> //
> //
> //
> package com.ibm.cimom;
> 
> 
> import java.io.*;
> import java.util.Enumeration;
> import java.util.Vector;
> import java.rmi.*;
> import java.rmi.server.*;
> import java.net.*;
> import com.ibm.cim.*;
> import com.ibm.xml.*;
> import com.ibm.indication.*;
> import com.ibm.cimom.util.*;
> import com.ibm.http.*;
> 
> //
> // The CIMOM!
> //
> public class CIMServer implements CIMImplementation  {
>     static private CIMServer localServer;
>     static private Vector nameSpaces=new Vector();  // ServerNameSpace instances
>     static public String url = "/cimom";  // TODO this should be set up when the
>                                           // CIMOM starts to reflect the
>                                           // actual url
>                                           // that its listening to
>     static public final String defaultNamespace = "\\root\\cimv2";
>     static public final String baseNameSpace = "\\";
>     private String userName;
>     private String password;
> 
>     //
>     // CIMServerLocate
>     //
>     public static synchronized CIMServer CIMServerLocate() throws CIMException{
>         return(localServer);
>     }
> 
>     //
>     // CIMServerGetNameSpaces
>     //
>     public static synchronized Vector CIMServerGetNameSpaces() {
>         Vector ret=new Vector();
> 
>         for(int j=0;j<nameSpaces.size();j++) {
>             ServerNameSpace sns=(ServerNameSpace)(nameSpaces.elementAt(j));
>             ret.addElement(sns.getNameSpace());
>         }
>         return(ret);
>     }
> 
>     //
>     // findNameSpace
>     //
>     private static synchronized ServerNameSpace findNameSpace(CIMObjectPath name)
>             throws CIMException {
>         String namespace=name.getNameSpace().replace('/', File.separatorChar);
>         namespace=namespace.replace('\\', File.separatorChar);
> 
>         int i;
> 
>         for(i=0;i<nameSpaces.size();i++) {
>             String ns=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
>             if ( ns.equalsIgnoreCase(namespace))
>                 return((ServerNameSpace)(nameSpaces.elementAt(i)));
>         }
>         throw new CIMException(CIMException.CIM_ERR_NAMESPACE_NOT_IN_MANAGER,namespace);
>      }
> 
>     //
>     // findNameSpace
>     //
>     public synchronized ServerNameSpace findNameSpace(CIMNameSpace ns)
>             throws CIMException {
>         String namespace=ns.getNameSpace();
> 	  namespace=namespace.replace('/', File.separatorChar);
>         namespace=namespace.replace('\\', File.separatorChar);
> 
>         int i;
> 
>         for(i=0;i<nameSpaces.size();i++) {
>             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
>             if ( str.equalsIgnoreCase(namespace))
>                 return((ServerNameSpace)(nameSpaces.elementAt(i)));
>         }
>         throw new CIMException(CIMException.CIM_ERR_NAMESPACE_NOT_IN_MANAGER,namespace);
>     }
> 
> 
> 
>     //
>     // removeNameSpace
>     //
>     public synchronized static void removeNameSpace(CIMNameSpace ns) throws CIMException
>     {
>         String namespace=ns.getNameSpace();
>         int i;
> 
>           // QW 513             For access control.
>         permit("config","delete","removeNameSpace("+ namespace +")");
> 
>         for(i=0;i<nameSpaces.size();i++) {
>             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
>             if ( str.equalsIgnoreCase(namespace)) {
>                 nameSpaces.removeElementAt(i);
>                 //
>                 // Search for any child namespaces and remove those
>                 //
>                 String parentNameSpace=ns.getNameSpace();
>                 int len=parentNameSpace.length();
> 
>                 for(;;) {
>                     //
>                     // Iterate until all paths scanned - note that this is
>                     // a recursive process
>                     //
>                     int j;
>                     Vector paths=CIMServer.CIMServerGetNameSpaces();
>                     for(j=0;j<paths.size();j++) {
>                         String childSpace=(String)(paths.elementAt(j));
> 
>                         if (childSpace.length()>len &&
>                             childSpace.substring(0,len).equalsIgnoreCase(parentNameSpace) &&
>                             childSpace.charAt(len)=='/') {
>                             CIMNameSpace childNameSpace=new CIMNameSpace(ns.getHost(),
>                                                                          childSpace);
>                             removeNameSpace(childNameSpace);
>                             break;
>                         }
>                     }
>                     if (j==paths.size())
>                         break;
>                 }
>                 return;
>             }
>         }
>         throw new CIMException(CIMException.CIM_ERR_NAMESPACE_NOT_IN_MANAGER,namespace);
>     }
> 
>     private static CIMClass create_Namespace() {
>         CIMClass cimClass=new CIMClass();
>         cimClass.setName(XMLNameSpace.NAMESPACECLASS);
> 
>         CIMQualifier cimQualifier=new CIMQualifier("provider");
>         cimQualifier.setValue(new CIMValue(XMLNameSpace.PROVIDER,
>                            CIMDataType.getPredefinedType(CIMDataType.STRING)));
> 
>         CIMQualifier cimQualifierKey=new CIMQualifier("key");
>         cimQualifierKey.setValue(new CIMValue("true",
>                            CIMDataType.getPredefinedType(CIMDataType.STRING)));
> 
>         CIMProperty cimProp=new CIMProperty();
>         cimProp.setType(CIMDataType.getPredefinedType(CIMDataType.STRING));
>         cimProp.setName(XMLNameSpace.NAMEPROPERTY);
> 
>         cimProp.addQualifier(cimQualifierKey);
> 
>         cimClass.addQualifier(cimQualifier);
>         cimClass.addProperty(cimProp);
>         return cimClass;
>     }
> 
>     //
>     // addNameSpace
>     //
>     public synchronized static void addNameSpace(CIMNameSpace ns)
>             throws CIMException
>         {
>         ServerNameSpace cns=new ServerNameSpace(ns);
>         String namespace=cns.getNameSpace();
>         int i;
> 
>         // QW 513       For access control.
>         permit("config", "create","addNameSpace(" + namespace + ")");
> 
>         for(i=0;i<nameSpaces.size();i++) {
>             String str=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
>             if ( str.equalsIgnoreCase(namespace)) {
> 			return;
>             }
>         }
>         nameSpaces.addElement(cns);
>         //
>         // Now create the __Namespace class
>         //
> 	  CIMClass cimClass = create_Namespace();
> 
>         CIMObjectPath classObjPath=new CIMObjectPath(
>                                 XMLNameSpace.NAMESPACECLASS,ns.getNameSpace());
>         try {
>             cns.deleteClass(classObjPath);
>         } catch (CIMException ce) {
>             //
>             // Do nothing - it might not have been created. However
>             // if it was there is now deleted so we can create it
>             // again!
>             //
>         }
>         cns.addCIMClass(classObjPath,cimClass);
> 
>         cns.makeHandle();
>     }
> 
>     //
>     // authenticate
>     //
>     public void authenticate(String iuserName,String ipassword)
>         throws RemoteException,CIMException {
>         //
>         // TODO - need to use these for authentication
>         //
>         userName=iuserName;
>         password=ipassword;
>     }
> 
> 
>     //
>     // CIMServer
>     //
>     public CIMServer() throws CIMException,RemoteException
>     {
>     }
> 
> 
> 
>     //
>     // CIMServer
>     //
>     public CIMServer(CIMNameSpace name) throws CIMException, RemoteException{
>         addNameSpace(name);
>     }
> 
> 
> 
>     //
>     // CIMServer
>     //
>     public CIMServer(CIMNameSpace name, String userName,String passwd)
>             throws CIMException,RemoteException {
>         addNameSpace(name);
>     }
> 
> 
>     //
>     // CIMServer
>     //
>     public CIMServer(CIMNameSpace name,String userName,String passwd,int protocol)
>             throws CIMException,RemoteException{
>     }
> 
> 
>     //
>     // createNameSpace
>     //
>     public synchronized void createNameSpace(CIMNameSpace ns)
>             throws RemoteException, CIMException{
>         addNameSpace(ns);
>     }
> 
> 
>     //
>     // deleteNameSpace
>     //
>     public synchronized void deleteNameSpace(CIMNameSpace cns)
>             throws RemoteException, CIMException{
>         String namespace=cns.getNameSpace();
>         int i;
> 
>         // QW 513
>         permit("config","delete","deleteNameSpace(" + namespace +")");
> 
>         for(i=0;i<nameSpaces.size();i++) {
>             String ns=((ServerNameSpace)(nameSpaces.elementAt(i))).getNameSpace();
>             if ( ns.equalsIgnoreCase(namespace)) {
>                 nameSpaces.removeElementAt(i);
>                 return;
>             }
>         }
>         throw new CIMException(CIMException.CIM_ERR_NAMESPACE_NOT_IN_MANAGER,namespace);
>     }
> 
> 
>     //
>     // deleteClass
>     //
>     public void deleteClass(CIMObjectPath path)
>             throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("class", path, null), "delete",
>                "deleteClass("+ path.getObjectName() +")");
> 
>         ServerNameSpace sns;
> 
>         sns=findNameSpace(path);
>         sns.deleteClass(path);
>     }
> 
> 
>     //
>     //deleteInstance
>     //
>     public void deleteInstance(CIMObjectPath path)
>                 throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("instance", path, null), "delete",
>                "deleteInstance("+path.getObjectName()+")");
> 
>         ServerNameSpace sns;
> 
>         sns=findNameSpace(path);
>         sns.deleteInstance(path);
>     }
> 
> 
> 
> 
>     //deleteQualifierType
>     //
>     public synchronized void deleteQualifierType(CIMObjectPath path)
>                 throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("qualifier", path, null), "delete",
>                "deleteQualifier("+path.getObjectName()+")");
> 
>         findNameSpace(path).deleteQualifierType(path);
>     }
> 
> 
>     //enumNameSpace
>     //
>     public Enumeration enumNameSpace(CIMObjectPath path, boolean deep) throws CIMException {
> 
> 		String nameSpace = path.getNameSpace().replace('/', File.separatorChar);
> 	      nameSpace=nameSpace.replace('\\', File.separatorChar);
> 
> 		Vector nsList = CIMServerGetNameSpaces();
> 
> 		int index = 0;
> 		Vector nsci = new Vector();
> 
> 		for (int i = 0; i < nsList.size(); i++) {
> 			String listNS = (String)nsList.elementAt(i);
> 			listNS.replace('/', File.separatorChar);
> 		      listNS.replace('\\', File.separatorChar);
> 			
> 			if (listNS.equals(nameSpace) == true) {
> 				index = i;
> 				break;
> 			}
> 		}
> 
> 		for (int i = index; i < nsList.size(); i++) {
> 			String listNS = (String)nsList.elementAt(i);
> 			listNS.replace('/', File.separatorChar);
> 		      listNS.replace('\\', File.separatorChar);
> 			
> 			CIMClass cimClass = create_Namespace();
> 			CIMInstance ci = cimClass.newInstance();
> 		      ci.setProperty("CreationClassName", new CIMValue(new String(XMLNameSpace.NAMESPACECLASS), new CIMDataType(CIMDataType.STRING)));
> 		      ci.setProperty("Name", new CIMValue(new String(listNS), new CIMDataType(CIMDataType.STRING)));
> 			nsci.addElement(ci);
> 		}
> 
> 		Enumeration enum = nsci.elements();
> 
> 		return enum;
>     }
> 
> 
>     //
>     // enumClass
>     //
>     public Enumeration enumClass(CIMObjectPath path,
>                    boolean deep,boolean localOnly)
>                    throws RemoteException , CIMException{
> 
>         // QW 513
>         permit(buildID("class", path, null), "read",
>                "enumerateClass("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).enumClass(path,deep,localOnly));
>     }
> 
> 
>     //
>     // enumClass
>     //
>     public Enumeration enumClass(CIMObjectPath path,
>                    boolean deep) throws RemoteException, CIMException {
>         // QW 513
>         permit(buildID("class", path, null), "read",
>                "enumerateClass("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).enumClass(path,deep));
>     }
> 
>     //
>     // enumInstances
>     //
>     public Enumeration enumInstances(CIMObjectPath path,
>                        boolean deep) throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("instance",path,null), "read",
>                "enumerateInstance("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).enumInstances(path,deep));
>     }
> 
> 
>     //
>     // enumInstances
>     //
>     public Enumeration enumInstances(CIMObjectPath path,
>                        boolean deep,
>                        boolean localOnly) throws RemoteException, CIMException{
>         // QW 513
>         permit(buildID("instance",path,null), "read",
>                "enumerateInstance("+path.getObjectName()+")");
> 
> 	  // Handle enumInstance requests for Namspaces
>         if (path.getObjectName().equals(XMLNameSpace.NAMESPACECLASS) == true) {
> 		return enumNameSpace(path, deep);	
> 	  }
> 
>         return(findNameSpace(path).enumInstances(path,deep,localOnly));
>     }
> 
>     //
>     // enumQualifierTypes
>     //
>     public Enumeration enumQualifierTypes(CIMObjectPath path)
>                 throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("qualifier",path,null), "read",
>                "enumerateQualifiers("+path.getNameSpace()+")");
> 
>         return(findNameSpace(path).enumQualifierTypes());
>     }
> 
> 
> 
>     //
>     // getClass
>     //
>     public CIMClass getClass(CIMObjectPath path,
>                boolean localOnly) throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("class",path,null), "read",
>                "getClass("+path.getObjectName()+")");
> 
>         if (localOnly)
>             return(findNameSpace(path).getCIMClass(path).localElements());
>         return(findNameSpace(path).getCIMClass(path));
>    }
> 
> 
>     //
>     // getInstance
>     //
>     public CIMInstance getInstance(CIMObjectPath path,
>                      boolean localOnly) throws RemoteException, CIMException {
> 
>         // QW 513
>         permit(buildID("instance",path,null), "read",
>                "getInstance("+path.getObjectName()+")");
> 
>         ServerNameSpace sns;
>         CIMInstance ci;
> 
>         sns=findNameSpace(path);
>         ci=sns.getInstance(path,localOnly);
> 
>         return(ci);
>     }
> 
> 
>     //
>     //invokeMethod
>     //
>     public CIMValue invokeMethod(CIMObjectPath path,
>                    String methodName,Vector in,
>                    Vector out) throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("method",path,"methodName"), "execute",
>                "invokeMethod" + path.getObjectName() + "." + methodName +"()");
> 
>         return(findNameSpace(path).invokeMethod(path,methodName,in,out));
>     }
> 
> 
>     //
>     // getQualifierType
>     //
>     public CIMQualifierType getQualifierType(CIMObjectPath path)
>             throws RemoteException, CIMException{
> 
>         // QW 513
>         permit(buildID("qualifier",path,null), "read",
>                "getQualifierType("+path.getObjectName()+")" );
> 
>         return(findNameSpace(path).getQualifierType(path));
>     }
> 
> 
>     //
>     // createQualifierType
>     //
>     public void createQualifierType(CIMObjectPath path,
>                       CIMQualifierType qt) throws RemoteException, CIMException{
>         // QW 513
>         permit(buildID("qualifier",path,null), "create",
>                "createQualifierType("+qt.getName()+")!" );
> 
>         findNameSpace(path).createQualifierType(path,qt);
>     }
> 
>     //
>     // setQualifierType
>     //
>     public void setQualifierType(CIMObjectPath path,
>                    CIMQualifierType qt) throws RemoteException, CIMException{
>         // QW 513
>         permit(buildID("qualifier",path,null), "write",
>                "setQualifierType("+qt.getName()+")" );
> 
>         findNameSpace(path).setQualifierType(path,qt);
>     }
> 
>     //
>     // createClass
>     //
>     public void createClass(CIMObjectPath path,
>               CIMClass cc) throws RemoteException , CIMException{
>         // QW 513
>         permit(buildID("class",path,null), "create",
>                "createClass("+cc.getName()+")");
> 
>         findNameSpace(path).addCIMClass(path,cc);
>     }
> 
> 
>     //
>     // setClass
>     //
>     public void setClass(CIMObjectPath path,
>            CIMClass cc) throws RemoteException, CIMException {
>         // QW 513
>         permit(buildID("class",path,null), "write",
>                "setClass("+cc.getName()+")");
> 
>         findNameSpace(path).setCIMClass(path,cc);
>     }
> 
> 
>     //
>     // createInstance
>     //
>     public CIMObjectPath createInstance(CIMObjectPath path,
>                  CIMInstance ci) throws RemoteException, CIMException{
>         // QW 513
>         permit(buildID("instance",path,null), "create",
>                "createInstance("+ci.getName()+")");
> 
>         return(findNameSpace(path).addCIMInstance(path,ci));
>     }
> 
> 
>     //
>     // setInstance
>     //
>     public void setInstance(CIMObjectPath path,
>               CIMInstance ci) throws RemoteException, CIMException{
>         // Qw 513
>         permit(buildID("instance",path,null), "write",
>                "setInstance("+ci.getName()+")");
> 
>          findNameSpace(path).setInstance(path,ci);
>     }
> 
> 
>     //
>     // getProperty
>     //
>     public CIMValue getProperty(CIMObjectPath path,
>                   String propertyName) throws RemoteException, CIMException{
>         // Qw 513
>         permit(buildID("property",path,propertyName), "read",
>                "getProperty("+ path.getObjectName() + "," + propertyName +")");
> 
>         return(findNameSpace(path).getProperty(path,propertyName));
>     }
> 
> 
>     //
>     // setProperty
>     //
>     public void setProperty(CIMObjectPath path,
>               String propertyName,
>               CIMValue newValue) throws RemoteException, CIMException{
>         // Qw 513
>         permit(buildID("property",path,propertyName), "write",
>                "setProperty(" +path.getObjectName() + "," + propertyName +")");
> 
>         findNameSpace(path).setProperty(path,propertyName,newValue);
>     }
> 
>     //
>     // associatorNames
>     //
>     public Enumeration associatorNames(CIMObjectPath path,String assocClass,
>                                         String resultClass,
>                                         String role,String resultRole) throws CIMException {
>         // Qw 513
>         permit(buildID("instance",path,null), "read",
>                "associatorNames("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).associatorNames(path,
>                                    assocClass,resultClass,role,resultRole));
>     }
> 
>     //
>     // associators
>     //
>     public Enumeration associators(CIMObjectPath path,
>                                         String assocClass,
>                                         String resultClass,
>                                         String role,
>                                         String resultRole,
>                                         boolean includeQualifiers,
>                                         boolean includeClassOrigin,
>                                         String propertyList[])throws CIMException {
>         // Qw 513
>         permit(buildID("instance",path,null), "read",
>                "associators("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).associators(path,assocClass,
>                           resultClass,role, resultRole,includeQualifiers,
>                           includeClassOrigin,propertyList));
>     }
> 
>     //
>     // referenceNames
>     //
>     public Enumeration referenceNames(CIMObjectPath path,
>                                         String resultClass,
>                                         String role) throws CIMException {
>         // Qw 513
>         permit(buildID("instance",path,null), "read",
>                "referenceNames("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).referenceNames(path,resultClass,role));
>     }
> 
>     //
>     // references
>     //
>     public Enumeration references(CIMObjectPath path,
>                                             String resultClass,
>                                             String role,
>                                             boolean includeQualifiers,
>                                             boolean includeClassOrigin,
>                                             String propertyList[]
>                                         ) throws CIMException {
>         // Qw 513
>         permit(buildID("instance",path,null), "read",
>                "references("+path.getObjectName()+")");
> 
>         return(findNameSpace(path).references(path,resultClass,role,
>                                               includeQualifiers,
>                                               includeClassOrigin,
>                                               propertyList));
>     }
> 
> 
>     //
>     // references
>     //
>     public static void createLocalServer(CIMNameSpace cns)throws CIMException,RemoteException {
>         localServer=new CIMServer();
>         localServer.addNameSpace(cns);
>     }
> 
> 
> 
> 	public static CIMServer initializeServer() throws Exception {
> 
> 		localServer=new CIMServer();
> 
>            	localServer.createNameSpace(new CIMNameSpace(
>                                InetAddress.getLocalHost().getHostName(),
>                                baseNameSpace));
> 
>            	localServer.createNameSpace(new CIMNameSpace(
>                                InetAddress.getLocalHost().getHostName(),
>                                XMLNameSpace.DEFNAMESPACE));
> 
> 		localServer.createNameSpace(new CIMNameSpace(
>                                InetAddress.getLocalHost().getHostName(),
> 					 defaultNamespace));
> 		
> 		if (TransactionThread.log != null) {
> 			TransactionThread.log.writeLog("CIMServer: Namespace " + defaultNamespace + " initialized");
> 		}
> 
> 		return localServer;
> 	}
> 
> 
>     // QW 427.   Methods for checking permission.
>     //    1.   buildID -- build permission ID
>     //    2.   permit
>     static String  buildID(String objType, CIMObjectPath op, String extType) {
>         String ns, obj;
> 
>         if ( objType == null || objType.length() <= 0 )
>             return new String("");
> 
>         StringBuffer sbuf = new StringBuffer(objType);
>         if ( op != null )  {
>                 ns = op.getNameSpace();
>                 obj = op.getObjectName();
>                 if ( op.getNameSpace() != null ) {
>                     sbuf.append(":" + op.getNameSpace());
>                     if ( op.getObjectName() != null ) {
>                             sbuf.append(":" + op.getObjectName());
>                             if ( extType != null )
>                                 sbuf.append(":"+extType);
>                     }
>                 }
>         }
>         return sbuf.toString();
>     }
> 
>     static void permit(String resource, String operation,
>                         String operationVerbose) throws CIMException {
> 
> /*
>         if (OperationPermission.requiresCheck &&
>             !OperationPermission.opImplementation.checkPermission(resource,
>                                                                   operation))
>             throw new CIMException(CIMException.CIM_ERR_ACCESS_DENIED,
>                                    "Insufficient permissions for " +
>                                    operationVerbose);
> */
>     }
> 
> 
> }
> 
> 
