#!/bin/sh

# Debugging info
echo  ENVIRONMENT
echo '-----------'
/usr/bin/env
echo

OS=`uname -s`
TSRMHOME=$1
INSTANCE_DAT=`ls $TSRMHOME/INSTANCE*.DAT`
INSTANCE=`expr $INSTANCE_DAT : '.*\([0-9][0-9]*\)\.DAT'`
CLASSDIR=$TSRMHOME/agent/lib
CLASSPATH=""
LIBPATH=""
SCRIPT=$TSRMHOME/agent/tsrmagt$INSTANCE
TEMPSCRIPT=${SCRIPT}.new

cleanUp()
{
	mv $SCRIPT ${SCRIPT}.old
	mv $TEMPSCRIPT $SCRIPT
	chmod 700 $SCRIPT
	rm -f ${SCRIPT}.old
}

setLibraryPath()
{
	LIBPATH=""
	PLATFORM=""
	SPATH=""

	if [ "$OS" = "HP-UX" ]
  	then
			PLATFORM="hp-ux_pa-risc"
			LIBPATH="SHLIB_PATH"
	fi
 	if [ "$OS" = "SunOS" ]
	then
        	PLATFORM="solaris_sparc"
        	LIBPATH="LD_LIBRARY_PATH"
  	fi
 	if [ "$OS" = "Linux" ]
	then
        	PLATFORM="linux_i386"
        	LIBPATH="LD_LIBRARY_PATH"
	fi
   SPATH="$LIBPATH=$TSRMHOME/agent/bin/$PLATFORM:$TSRMHOME/install"

	echo $SPATH >> $TEMPSCRIPT

	echo >> $TEMPSCRIPT
	echo "if udblib=\`\$TSRMHOME/install/findudb\`" >> $TEMPSCRIPT
	echo "then" >> $TEMPSCRIPT
	echo "   $LIBPATH=\$$LIBPATH:\$udblib/lib" >> $TEMPSCRIPT
	echo "fi" >> $TEMPSCRIPT
	echo >> $TEMPSCRIPT

	LC_ALL=`grep "LC_ALL=" $SCRIPT`

	if test -z "$LC_ALL"
   then
		echo "export $LIBPATH" >> $TEMPSCRIPT
	else
		echo "$LC_ALL" >> $TEMPSCRIPT
		echo " " >> $TEMPSCRIPT
		echo "export $LIBPATH LC_ALL" >> $TEMPSCRIPT
	fi
}

echo "#!/bin/sh" > $TEMPSCRIPT
echo "trap '' 1" >> $TEMPSCRIPT
echo >> $TEMPSCRIPT
echo "# " >> $TEMPSCRIPT
echo "# `date`" >> $TEMPSCRIPT
echo "# " >> $TEMPSCRIPT
echo >> $TEMPSCRIPT
echo "DYNAMIC_CLASSPATH=\"\"" >> $TEMPSCRIPT


echo "setClassPath()" >> $TEMPSCRIPT
echo "{" >> $TEMPSCRIPT
echo "        BEG=\"TRUE\"" >> $TEMPSCRIPT
echo "        for f in $CLASSDIR/*.jar $CLASSDIR/*.zip" >> $TEMPSCRIPT
echo "        do" >> $TEMPSCRIPT
echo "                if [ \$BEG = "TRUE" ]" >> $TEMPSCRIPT
echo "                then" >> $TEMPSCRIPT
echo "                        DYNAMIC_CLASSPATH=\"\$f\"" >> $TEMPSCRIPT
echo "                else" >> $TEMPSCRIPT
echo "                        DYNAMIC_CLASSPATH=\"\$DYNAMIC_CLASSPATH:\$f\"" >> $TEMPSCRIPT
echo "                fi" >> $TEMPSCRIPT
echo "                BEG=\"FALSE\"" >> $TEMPSCRIPT
echo "        done" >> $TEMPSCRIPT
echo "}" >> $TEMPSCRIPT

#
# Create Environment Variables
#
JAVAEXEC=`cat $INSTANCE_DAT`

#setClassPath

echo "TSRMHOME=$TSRMHOME" >> $TEMPSCRIPT
echo "JAVAEXEC=$JAVAEXEC" >> $TEMPSCRIPT
echo "setClassPath" >> $TEMPSCRIPT
echo "CLASSPATH=\$DYNAMIC_CLASSPATH" >> $TEMPSCRIPT

setLibraryPath

echo " " >> $TEMPSCRIPT
echo "cd \$TSRMHOME" >> $TEMPSCRIPT
echo " " >> $TEMPSCRIPT
echo "case \$1 in" >> $TEMPSCRIPT
echo "'start')" >> $TEMPSCRIPT
echo "   exec \$JAVAEXEC -Xrs -Xmx128m -cp \$CLASSPATH com.tivoli.itsrm.agent.svp.Agent &" >> $TEMPSCRIPT
echo "   ;;" >> $TEMPSCRIPT
echo "'stop')" >> $TEMPSCRIPT
echo "   if test -n \"\$2\"" >> $TEMPSCRIPT
echo "   then" >> $TEMPSCRIPT
echo "      shutdownmode=\$2" >> $TEMPSCRIPT
echo "   else" >> $TEMPSCRIPT
echo "      shutdownmode=abort" >> $TEMPSCRIPT
echo "   fi" >>  $TEMPSCRIPT
echo "exec \$JAVAEXEC -cp \$CLASSPATH com.tivoli.itsrm.agent.svp.UnixStopAgent \$shutdownmode &" >> $TEMPSCRIPT
echo "   ;;" >> $TEMPSCRIPT
echo " *)" >> $TEMPSCRIPT
echo "   echo  \"Usage \$0 { start | stop }\"" >> $TEMPSCRIPT
echo "   ;;">> $TEMPSCRIPT
echo "esac" >> $TEMPSCRIPT

cleanUp
