sqlcount = 24

##########################################################################
# Non dbms specific repository update script. 
# Processed by TrelliSoft.install.RepositoryAlter
# 
# This file must have the following format:
# 1) The first line of the file must contain a count of the sql stmts
#    included in the line. This info is used to update a progress bar
#    as the sql file is being processed. This line should be in the
#    format:
#        sqlcount = <n>
#    where <n> represents the # of statements contained in the file
#
# 2) Each sql statement must be terminated by a ';' as the first char
#    of a new line. Everything else on the terminator line is ignored.
#
# 3) Comments are denoted by a '#' as the first char of a line. Everything
#    on a comment line is ignored
#
# Parameter Values (see TrelliSoft.install.RepositoryInstall for all DBs):
#
# Parm    Oracle Value        MSSQL Value
# ----    ------------        ----------------------------------------------
# {0}     decimal(10)         integer
# {1}     decimal(5)          smallint
# {2}     raw(20)             varbinary(20)
# {3}     date                datetime
# {4}     long                text    
# {5}     long raw            image   
# {6}     <empty>             case_mask varbinary(8) default 0x00 not null,
# {7}     <empty>             case_mask varbinary(64) default 0x00 not null,
# {8}     sysdate             current_timestamp
# {9}     '20'                ' '
# {10}    <empty>             , case_mask
# {11}    <empty>             0x00,
# {12}    float               float
# {13}    raw(60)             varbinary(60)
# {14}    <empty>             t_res_attribute
###########################################################################

alter table t_stat_user 
  add   unused_size decimal(13)    default 0 not null
;
alter table t_stat_user 
  add   other_count {0}            default 0 not null
;

alter table t_storm_settings 
  add  keep_removed_db {1}        default 7 not null
;
alter table t_storm_settings 
  add  keep_removed_ts {1}        default 7 not null
;
alter table t_storm_settings 
  add  keep_removed_tb {1}        default 7 not null
;
alter table t_storm_settings 
  add  ts_daily_hist   {1}        default 6 not null
;
alter table t_storm_settings 
  add  ts_weekly_hist  {1}        default 4 not null
;
alter table t_storm_settings 
  add  ts_monthly_hist {1}        default 2 not null
;
alter table t_storm_settings 
  add  tb_daily_hist   {1}        default 6 not null
;
alter table t_storm_settings 
  add  tb_weekly_hist  {1}        default 4 not null
;
alter table t_storm_settings 
  add  tb_monthly_hist {1}        default 2 not null
;

alter table t_report_prefs
  add  domain_max_rows   {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  network_max_rows  {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  quota_max_rows    {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  datafile_max_rows {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  ts_max_rows       {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  ts_grp_max_rows   {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  database_max_rows {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  instance_max_rows {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  tb_max_rows       {0}      default 2147483647 not null
;
alter table t_report_prefs
  add  tb_grp_max_rows   {0}      default 2147483647 not null
;

alter table t_saved_report
  add  product_code      char(1)  default '1' not null
;

drop  index {14}t_res_stat_dir_ix
;

create unique index t_res_stat_dir_ix
  on t_res_stat_dir (directory_id, res_directory_id)
;
